/*
 * main.c
 *
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <stdio.h>

#include "lcd.c"
#include "timer.c"
#include "sensor.c"

int main(void) {

  char str[128];

  InitLCD();
  InitDistanceSensor();
  InitEngineTimer();

  sei();

  _delay_ms(10000);

  Move(800);

  while(1){
    sprintf(str, "D: %6d", GetDistanceSensor());
    LCDPrintXY(str, 32, 4);

    sprintf(str, "S: %6d", _step_target);
    LCDPrintXY(str, 32, 16);

    _delay_ms(1000);
  }

  return 0;

}
