/*
 * sensor.c
 *
 */

#include <math.h>

void InitDistanceSensor(){

  // Reset registers
  ADMUX = ADCSRA = 0;

  // External reference voltage at 5V
  // Single input on ADC0 (PA0)
  ADMUX |= (1 << REFS0);

  // Set ADC prescaler 128
  ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);

  // Enable ADC
  ADCSRA |= (1 << ADEN);

}

int GetDistanceSensor(){

  int result;

  // Begin conversion
  ADCSRA |= (1 << ADSC);

  // Wait for conversion to finish
  while(ADCSRA & (1 << ADSC))
    ;
 
  // Experime
  result = (int)(65 * pow(0.00488281 * ADC, -1.10));

  // Check if result is in sensor detection range
  if(result < 20 || result > 150){
    result = -1;
  }

  return result;

}
